;******************************************************************************
;    Filename: 1-Wire_Task.asm                                                *
;    Date:     15/12/2015                                                     *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC,LCD_Text.asm           *
;                                                                             *
;******************************************************************************
	#include Define.inc	;     
;      1-Wire     -0
;   1/4,   = 1/3 ,      3	
;*****************************************************************************
 #ifdef	W1_Pin	;    -      
;     AddIncludeFiles.bat
;*****************************************************************************
	
	#include Proj_Dir\1W\1-Wire_Task_M.inc	;    - 
	;extern	T5_R1,T5_R2,T5_R3,T5_R4;
	extern	InitAll,CaseBra;Table_1W;CalcCRC,
	global	W1_Task

W1_Task	code
W1_Task
		W1_Page	; movlb	0x0					; BSR  0  StepTask
	movlf	MaxW1Pointer,W1_Temp,BANKED; - GoToWreg,BANKED	;    
	movf	W1_Route,W,BANKED	;
	;bz		DoneW1_Task		;   -   "" 1-Wire
	cpfsgt	W1_Temp,BANKED			; (f) - (WREG) skip if (f) > (WREG); (unsigned comparison)
		retlw	0x0	;bra		DoneW1_Task		;    -  

;	GoToWreg	1,W1_Temp,BANKED ; NumShiftWreg,TempBuff,Adr1     WREG, 1   -
;     .
	


	BraReg	W1_Route,BANKED	;;BraReg	macro	RegPoint,Adr1 ;    -  
	;rcall	CaseBra	;   WREG -     -  

;    2   BRA  RETLW. BRA   +/- 1024 ,   .
;     +/- 127 .
	#include Proj_Dir\1W\1-Wire_Task.INC	;    

Step_0	; 
 .if	Debug_1W == 0;       
;**************
; 	btfsc		W_1_Flg,4,ACCESS		;   ? 
;	retlw	0x0	;    
;**************
; .else
 .endif
 #ifdef	LCD_Present
	movff KeyBuf,W1_KeyBuf	;         
 #endif
;	btfsc	W1_KeyBuf,7,0		;    
; retlw	0x0					;

;        
	movf	W1_AlgRoute,W,BANKED	;  , 0=  1- 
;6=         -  
	addwf	W1_Route,F,BANKED	;   
	;incf	W1_Route,F,BANKED	;   
	retlw	0x0	;      	
;   -      1-,    
;      1- 
;   -        ,         
;   -         ""         
; -  -  , . 
;   ""    6.  -   34

Step1	;   -0 -    
	movlf		d'6',W1_Convert_Return,BANKED	;   / 
	movlw		DS1820_SKIP_ROM	;;   SKIP_ROM
	btfss	W1_KeyBuf,7,BANKED	;    
	movlw		DS1820_READROM	;;   READROM   
; retlw	0x0					;
;	bra		Done_Step_6	; 
; 		bra ReadBufCircle ; 

	movwf	W_1_CmdBuf,BANKED ;      

	bra		Step_40	;  / /////
				;retlw	0x0

;*********        Table_1W
Step2	;  -0      
	;incf	W1_Route,F,BANKED	;   	
	movlf		d'10',W1_Convert_Return,BANKED	;   / 40 
	movlf	DS1820_MATCHROM,W_1_CmdBuf,BANKED ;   _ROM      40
;    .          
  rcall	Read_1W_Table	;     W1_Sensor_Count,   
	lfsr	0,	DS1820_ScratctPad1	;            
	movff16	FSR0L,ScratctPad_Ptr1;     	 	
	bra		Step_40	;  /     1-
Step_3	;  ,   
	;movlf		d'41',W1_Route,BANKED	;   41   
	clrf	W_1_ReadBuf,ACCESS	;     "".
	;movlf	DS1820_SKIP_ROM,W_1_WriteBuf,BANKED ;   SKIP_ROM   
	;movlf		d'41',W1_Write_Return,BANKED	;      -  41
	movlf		d'0',W1_Drv_Return,BANKED ;      - 
			bra		Step_36	;    1-
	clrf	W1_Route,BANKED	;   
 retlw	0x0
Step_4	;;  , ,    
	;movlf		d'41',W1_Route,BANKED	;   41   
	;clrf	W_1_ReadBuf,ACCESS	;     "".
	;movlf	DS1820_SKIP_ROM,W_1_WriteBuf,BANKED ;   SKIP_ROM   
	movlf	DS1820_READ_SCRATCHPAD,W_1_WriteBuf,BANKED	;    
	movlf	d'0',W1_Read_Return,BANKED ;  ""  /   -  
	movlf	d'34',W1_Write_Return,BANKED	;      - 
	movlf	d'35',W1_Drv_Return,BANKED ;      - 
			bra		Step_36	;    1-
	clrf	W1_Route,BANKED	;   
 retlw	0x0
Step_5	;;  , , ,
	movlf	DS1820_READROM,W_1_WriteBuf,BANKED ;   
	movlf	d'0',W1_Read_Return,BANKED ;  ""  /   -  
	movlf	d'34',W1_Write_Return,BANKED	;      - 
				bra		Step_35	;    1-

	clrf	W1_Route,BANKED	;   
	movlf		d'41',W1_Route,BANKED	;   41   
	clrf	W_1_ReadBuf,ACCESS	;     "".
	movlf	DS1820_SKIP_ROM,W_1_WriteBuf,BANKED ;   SKIP_ROM   
	movlf		d'41',W1_Write_Return,BANKED	;      -  41
	movlf		d'35',W1_Drv_Return,BANKED ;      - 
			bra		Step_36	;    1-
	clrf	W1_Route,BANKED	;   
 retlw	0x0

Step_6	;   CONVERT_T   READ_SCRATCHPAD -  
	movff	W_1_ReadBuf,W1_Rx_Byte	;  "",  

 .if	Debug_1W == 0;       
 btfss	W_1_ReadBuf,7,ACCESS	;   ? 
		bra		SensorNotPresent
; .else
 .endif

;****;***     -   
	btfsc	W1_KeyBuf,7,BANKED	;    
; retlw	0x0					;
	bra		Done_Step_6	; 
 		bra Step_7 ; 
SensorNotPresent	;    ""  ,  .
	bcf			W_1_Flg,2,ACCESS		;      
	clrf	W1_Route,BANKED	;  -    
	bsf			W_1_Flg,0,ACCESS		;  1-Wire  
	movlf		0xA5,DS1820_ScratctPad+1,BANKED
	movlf		0x5A,DS1820_ScratctPad,BANKED
			retlw	0x0	;   1-    
Done_Step_6
	incf	W1_Route,F,BANKED	;   	
	movff		W1_Route,W1_Write_Return	;    -  
	movlf	DS1820_READ_SCRATCHPAD,W_1_WriteBuf,BANKED	;    
		bra		Step_35	;     1-

Step_7	
	btfsc	W_1_Flg,3,ACCESS		;       ?
		bra		NextByteRead		;
	bsf		W_1_Flg,3,ACCESS		;  ,     8 
	clrf	DS1820_CRC,BANKED		;  CRC
	movlf	d'7',W1_Read_Return,BANKED ;  ""  /  

;****;***     -   
	movlw		d'9'	;;  -  9 
	btfss	W1_KeyBuf,7,BANKED	;    
	movlw		d'8'	;;  -  8 
	movwf	W1_Byte_Count,BANKED ;      

	lfsr	0,	DS1820_ScratctPad
	movff16	FSR0L,ScratctPad_Ptr;     		
		bra		Step_34	;     1-
NextByteRead
	movff16	ScratctPad_Ptr,FSR0L;      
	movff	W_1_ReadBuf,POSTINC0;   1-   

	movff16	FSR0L,ScratctPad_Ptr;     
	decfsz	W1_Byte_Count,F,BANKED	;   ?
		bra		Step_34	;     1-
		;bra		AllByteRead
AllByteRead
;      
;    
	tstfsz		DS1820_CRC,BANKED		;
		incf		DS1820_Err_CRC,F,BANKED	;
	tstfsz		DS1820_CRC,BANKED		;
;	movf		DS1820_CRC,W,BANKED		;   Z    CRC
  bra	SkipTempConversion	;    -    
		LED1_Toggle ; btg		FotoFire			;    btg		Debug_LED
;	rcall	TempBCD	;    ,    
SkipTempConversion
	clrf	W1_Route,BANKED	;  -    
	bcf			W_1_Flg,2,ACCESS		;    "".
	bcf			W_1_Flg,1,ACCESS		;     .
	bsf			W_1_Flg,0,ACCESS		;  1-Wire  
	bcf			W_1_Flg,3,ACCESS		;     
	bsf			W_1_Flg,4,ACCESS		;    
	retlw	0x0	;   1-    

		retlw	0x0
Step_10	;      
;      - 
; .if	Debug_1W == 0;       
; btfss	W_1_ReadBuf,7,ACCESS	;   ? 
;		bra		SensorNotPresent
;; .else
; .endif
;
	incf	W1_Route,F,BANKED	;   
 rcall	Read_1W_Table	;     ,    W1_Sensor_Count
	movlf	d'8',W1_Byte_Count,BANKED;     
	lfsr	0,	DS1820_ScratctPad	;   
	movff	POSTINC0,W_1_WriteBuf	;      
	movff16	FSR0L,ScratctPad_Ptr;     		
	movff		W1_Route,W1_Write_Return	;    -  
		bra		Step_35	;       1-
; retlw	0x0
Step_11	;      
	movff16	ScratctPad_Ptr,FSR0L;      
	movff	POSTINC0,W_1_WriteBuf	;      
	movff16	FSR0L,ScratctPad_Ptr;     
	decfsz	W1_Byte_Count,F,BANKED	;   ?
		bra		Step_35	;      1-
;     ,        
	incf	W1_Route,F,BANKED	;   	
	movff		W1_Route,W1_Read_Return	;      -  
	movlf	d'34',W1_Write_Return,BANKED;      -   
	movlf	DS1820_READ_SCRATCHPAD,W_1_WriteBuf,BANKED	;    
	movlf	d'9',W1_Byte_Count,BANKED;    
	clrf	DS1820_CRC,BANKED		;  CRC
	lfsr	0,	DS1820_ScratctPad	;     
	movff16	FSR0L,ScratctPad_Ptr;     
		bra		Step_35	;     1-
; retlw	0x0
Step_12	;      
	movff16	ScratctPad_Ptr,FSR0L;      
	movff	W_1_ReadBuf,POSTINC0;   1-   
	movff16	FSR0L,ScratctPad_Ptr;     
	decfsz	W1_Byte_Count,F,BANKED	;   ?
		bra		Step_34	;     1-
;AllByteRead
		;btg		FotoFire			;    btg		Debug_LED
 movff16	ScratctPad_Ptr1,FSR0L;      	
;         
	movf		DS1820_CRC,W,BANKED		;   Z    CRC
  bnz	SkipCopyTemp	;    -     
 movff	DS1820_ScratctPad,POSTINC0	;   
 movff	DS1820_ScratctPad+1,POSTINC0;   

		LED1_Toggle ;*****************	Debug_LED

	bra		NewSens
SkipCopyTemp
	movf	POSTINC0,W,ACCESS	;   
	movf	POSTINC0,W,ACCESS	;   
NewSens
	movff16	FSR0L,ScratctPad_Ptr1;      	
	dcfsnz	W1_Sensor_Count,F,BANKED	;
		bra	AllTempGet	;Step_13 ;NewSens1	;    
NewSens1	; , ,   10
;   -  , 
	clrf	W_1_ReadBuf,ACCESS	;     "".
	movlf	DS1820_MATCHROM,W_1_WriteBuf,BANKED	;   ROM   
	movlf	d'10',W1_Write_Return,BANKED;     -  10,  
	movlf	d'35',W1_Drv_Return,BANKED ;    - 
			bra		Step_36	;    1-
; **********      *********************
AllTempGet	;
;	Beeper	d'2'; 
 #include Proj_Dir\1W\1-W_Temp.inc	;  
; **********        ***********
Step_13
	movlf	d'13',W1_Route,BANKED	;      
;  ,    
;WaitTimeL	MACRO Literal8,TimeCounter,Adr0,TimeStamp,Adr1	;    
 WaitTimeL	d'67',Tic_100_Counter,ACCESS,W1_TimeStamp,BANKED,0xE1




	clrf	W1_Route,BANKED	;  -    
	bcf			W_1_Flg,2,ACCESS		;     / Read_1W_Table.
	bcf			W_1_Flg,1,ACCESS		;     .
	bsf			W_1_Flg,0,ACCESS		;  1-Wire  
	bcf			W_1_Flg,3,ACCESS		;     
	bsf			W_1_Flg,4,ACCESS		;    
	retlw	0x0	;   1-    
 retlw	0x0

Step_34 ;   2   7    
						;   /
	btfsc	W_1_Flg,1,ACCESS		;       ?
		bra		NextBitRead		;
	bsf		W_1_Flg,1,ACCESS		;  1-Wire   
	movlf	d'8',W1_Bit_Count,BANKED	;  
	movlf	d'34',W1_Drv_Return,BANKED ;  ""   
		bra		Step_39				;  ,      

NextBitRead 
;        
; call CalcCRC ;           - 
	rrncf	DS1820_CRC,F,BANKED	;    
	movf	DS1820_CRC,W,BANKED	;
	bcf		DS1820_CRC,7,BANKED	;   (  )
	xorwf	W_1_ReadBuf,W,BANKED;  XOR     CRC
;    
 	bnn		DoneXor	;      (-7)
	movlw	b'10001100'	; *************   " "
	xorwf	DS1820_CRC,F,BANKED	;    
DoneXor

	dcfsnz	W1_Bit_Count,F,BANKED	;   ?
		bra		EndReadByte
	rrncf	W_1_ReadBuf,F,BANKED	;   ,     7 .
		bra		Step_39				;  ,      
EndReadByte
	bcf		W_1_Flg,1,ACCESS		;  1-Wire   
	movf	W1_Read_Return,W,BANKED	;   
	movwf	W1_Route,BANKED	; WREG 
		bra	W1_Task	;      
	bsf		W_1_Flg,0,ACCESS		;  1-Wire  
				retlw	0x0
Step_35 ;    ,  ,    ,  / 40
						;   /
	btfsc	W_1_Flg,1,ACCESS		;       ?
		bra		NextBitWrite		;
	bsf		W_1_Flg,1,ACCESS		;  1-Wire   
	movlf	d'9',W1_Bit_Count,BANKED	;     
	movlf	d'35',W1_Drv_Return,BANKED ;  ""   
NextBitWrite
	dcfsnz	W1_Bit_Count,F,BANKED	;   ?
		bra		EndWriteByte
	rrcf	W_1_WriteBuf,F,BANKED	;   
		bc		Step_38				;  
		bra		Step_37				;  
EndWriteByte
	bcf		W_1_Flg,1,ACCESS		;  1-Wire   
	movf	W1_Write_Return,W,BANKED	;   
	movwf	W1_Route,BANKED	; WREG 
		bra	W1_Task	;      
	bsf		W_1_Flg,0,ACCESS		;  1-Wire  
				retlw	0x0
Step_36 ;     1  /  40
; "" Reset 1-W.   -  .
;F-1.   ,  ,   1   5
;   480  /, 2=70, 3=410,  ,
;      1-W,
;      1  ""
	movlf	d'1',Int_T5_Route,ACCESS	;  1   5
	SetDelay	d'480',TMR0L,ACCESS;   1 = 480  /
	SetDelay	d'70',Delay_T5_N2,BANKED;   2 = 70
 	SetDelay	d'410',Delay_T5_N3,BANKED;   3 = 410

W1_Begin	;    
		W1_Clear	;  		
 .if	Debug_1W == 0
 ;   
 .else
;	setf	PR5H,ACCESS				; 
;	setf	PR5L,ACCESS				; 
;	clrf	TMR5H,ACCESS			; 
;	clrf	TMR5L,ACCESS			; 
;	bcf		PIE3,TMR5IE,ACCESS			;   5 
; ;incf	TMR0L,F,ACCESS; *********      
 .endif

;	bcf		INTCON,GIEL,ACCESS		;    	
	bcf		INTCON,GIEH,ACCESS		;    	
 		W1_Output	;  ,      
	bsf		T0CON,TMR0ON,ACCESS		;   
 .if	Debug_1W == 0
 ;   
 .else
 ;	bsf		T5CON,TMR5ON,ACCESS		;   
 ;bcf	PIR3,TMR5IF,ACCESS; *********      -    
;	bcf		INTCON,TMR0IF,ACCESS		;;   0
 .endif

	bsf		INTCON,GIEH,ACCESS		;    	
;	bsf		INTCON,GIEL,ACCESS		;    
 bcf W_1_Flg,0,ACCESS ; *****  1-Wire        
	movff		W1_Drv_Return,W1_Route	;;      1  ""
				retlw	0x0

Step_37 ;      
; "" Write 0 bit Send 0 bit to the 1-Wire slaves.   -  .
; F-2.  ,  ,   4   5
;   60  /   2 (10)  ,  ,
;      ,
;      (     1  "")
	movlf	d'4',Int_T5_Route,ACCESS	;  4   5
	SetDelay	d'60',TMR0L,ACCESS;   1 = 60  /
	SetDelay	d'10',Delay_T5_N2,BANKED;   2 = 10
		bra		W1_Begin		;   - ,    
Step_38 ;      
;"" Write 1 bit Send 1 bit to the 1-Wire slaves
;F-3.  ,  ,   4   5
;   6  /   2 (64)  ,  ,
;      ,
;      (     1  "")
	movlf	d'4',Int_T5_Route,ACCESS	;  4   5
	SetDelay	d'6',TMR0L,ACCESS;   1 = 6  /
	SetDelay	d'64',Delay_T5_N2,BANKED;   2 = 64
		bra		W1_Begin		;   - ,    
Step_39 ;    ""
;  ""   , / 40 2 
; "" Read bit Read a bit from the 1-Wire slaves (Read time slot)
;F-4.  ,  ,   1   5
;   6  /, 2=9, 3=55,  ,
;      ,
;      (     1  "")
	movlf	d'1',Int_T5_Route,ACCESS	;  1   5
	SetDelay	d'6',TMR0L,ACCESS;   1 = 6  /
	SetDelay	d'9',Delay_T5_N2,BANKED;   2 = 9
 	SetDelay	d'55',Delay_T5_N3,BANKED;   3 = 55
		bra		W1_Begin		;   - ,    
Step_40	;	/ ,  "",  "",   ,
;  ,   ROM   W_1_CmdBuf.    .
	movlf		d'41',W1_Route,BANKED	;   41   
	clrf	W_1_ReadBuf,ACCESS	;     "".
	movlf	DS1820_SKIP_ROM,W_1_WriteBuf,BANKED ;   SKIP_ROM   
	movlf		d'41',W1_Write_Return,BANKED	;      -  41
	movlf		d'35',W1_Drv_Return,BANKED ;      - 
			bra		Step_36	;    1-
Step_41
	movff	W_1_ReadBuf,W1_Rx_Byte	;  "",  

 .if	Debug_1W == 0;       
 btfss	W_1_ReadBuf,7,ACCESS	;   ? 
; .else
 .endif
;	nop ;******************   
;****;***     -   
	bra		Done_Step_41
 ;bra ReadBufCircle ; 

;    ""  ,  .
	bcf			W_1_Flg,2,ACCESS		;      
	clrf	W1_Route,BANKED	;  -    
	bsf			W_1_Flg,0,ACCESS		;  1-Wire  
	movlf		0xA5,DS1820_ScratctPad+1,BANKED
	movlf		0x5A,DS1820_ScratctPad,BANKED
			retlw	0x0	;   1-    
Done_Step_41

 ;btg		FotoFire			;    btg		Debug_LED	

	movlf	DS1820_CONVERT_T,W_1_WriteBuf,BANKED ;       
	movlf	d'42',W1_Write_Return,BANKED	;      -   42
;	clrf	W_1_ReadBuf,ACCESS	;     "" -  .
	movff	Tic_100_Counter,W1_TimeStamp;	   1/100 
			bra		Step_35	;    
Step_42

; .if	Debug_1W == 0;       
;	btfsc	W_1_ReadBuf,7,ACCESS	;   ?
; ;.else
; .endif
;						nop	;*****************   
;	bra		Done_Step_42
;	movlf		d'42',W1_Drv_Return,BANKED ;       -  
;		bra		Step_39				;   "",      
;
Done_Step_42
;			movff TicsCounter,W1_TimeStamp	;    1/200 
		;clrf	W1_Route,BANKED	;  -    
	clrf	W_1_ReadBuf,ACCESS	;     "".
	movff	W_1_CmdBuf,W_1_WriteBuf;,BANKED ;    ROM   
	movff	W1_Convert_Return,W1_Write_Return;,BANKED	;      -  40
	movlf		d'35',W1_Drv_Return,BANKED ;      - 
			bra		Step_36	;    1-
; ********       
;TempBCD	;      
;;    .   -     
;;         16
;;   2  -  07   12 
;	swapf		DS1820_ScratctPad,W,BANKED		;       
;	andlw		0x0F	;,    
;	movwf		Tmp_0,BANKED				;  
; 	swapf		DS1820_ScratctPad+1,W,BANKED	; 	
;	andlw		0xF0	;   
;	addwf		Tmp_0,W,BANKED		;      
;	movwf		W1_TempInt,BANKED	;       
;	movf		DS1820_ScratctPad,W,BANKED		;     
;	andlw		0x0F	;,      
; btfsc		W1_TempInt,7,BANKED	;     ?
;		sublw	d'1'	;   
;	andlw		0x0F	;,      
;	mullw		d'10'	;     10,  1610=160   PRODL
;	swapf		PRODL,W,ACCESS	; 	   16
;	andlw		0x0F	;,       *10/16=  0-9
;	movwf		W1_TempDot,BANKED	;	 
;		return
Read_1W_Table
;              
;    
	;movff24	TBLPTRL,TBLPTR_1W_Temp_1	;   
	btfsc	W_1_Flg,2,ACCESS		;      ?
		bra		ReadDone
	bsf		W_1_Flg,2,ACCESS
	movlf	low(Table_1W+1),TBLPTRL,ACCESS	; 
	movlf	high(Table_1W+1),TBLPTRH,ACCESS	;  +1 (  )
	clrf	TBLPTRU,ACCESS
	BSF EECON1, EEPGD,0 ; Point to PROGRAM memory
	tblrd*+	;    -   .
	movff	TABLAT,W1_Sensor_Count	;
	movff16	TBLPTRL,TBLPTR_1W_Temp_1	;   
		bra		AllAdrRead ;    -    
ReadDone	
	movff16	TBLPTR_1W_Temp_1,TBLPTRL	;   
	clrf	TBLPTRU,ACCESS
	movlf	d'8',W1_Byte_Count,BANKED;     
	lfsr	0,	DS1820_ScratctPad	;
	BSF EECON1, EEPGD,0 ; Point to PROGRAM memory
LoopRead
	tblrd*+	;  
	movff	TABLAT,POSTINC0
	decfsz	W1_Byte_Count,F,BANKED	;   ?
		bra		LoopRead	;  
AllAdrRead
	movff16	TBLPTRL,TBLPTR_1W_Temp_1	;   
	;movff24	TBLPTR_1W_Temp_1,TBLPTRL	;   
		;bra		AllByteRead
		return

;****    DB   code   ר  
;****    ˨
;****  code_pack   
Table_1W	code_pack; 0x800			;        - BRA  
	global	Table_1W	;    -   ,    .
;		Extern	InitAll
		;      NOP
	goto	InitAll			;       - 
Table_1W	;   1-wire 
		db	d'0',d'3'	;     
#ifdef PCPWM_Board ;       
		db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
		db	0x28,0xBC,0x75,0x39,0x01,0x00,0x00,0xAB	;   0724C3-422AE  
		db	0x28,0x5B,0x76,0x39,0x01,0x00,0x00,0x49	;   0724C3-422AE    
#else ;       - , , 
		db	0x28,0xBC,0x75,0x39,0x01,0x00,0x00,0xAB	;   0724C3-422AE  
		db	0x28,0x5B,0x76,0x39,0x01,0x00,0x00,0x49	;   0724C3-422AE    
		db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
#endif
;
;*****************************************************************************
; #ifdef	W1_Pin	;    -      
;     AddIncludeFiles.bat
;*****************************************************************************
 #endif
;End of program
		END
