;Include for: PCPWM_3F_4431.asm
;SpeedChange	;   /   / PCPWM 
;  18 750/PCPWM_Accelerate  -   PCPWM_Accelerate,PCPWM_AccelCounter
;    :
; 1.  ,  =1 ,   ,   
; 2. ,   ,    
; 3.  ,          
;   StopMotor  FullStopMotor          
;   -       ,
;   ,       1,
;  /    PCPWM_Flag,3,ACCESS		; /
;         
;  PCPWM_SpeedStop  PCPWM_WorkSpeed      
;  PCPWM_Speed  PCPWM_Speed_M0/PCPWM_Speed_M1   2  

 	movff	PCPWM_Accelerate,PCPWM_AccelCounter;     
  PCPWM_Page	; BSR for PCPWM Task

	bcf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   

	movf	PCPWM_SpCh_Route,W,BANKED	;
 bz		SpCh_R0 ; 0.  ,     .
	dcfsnz	WREG,W,ACCESS	
 bra	SpCh_R1 ; 1.    ,  -   .
	dcfsnz	WREG,W,ACCESS	
 bra	SpCh_R2 ; 2.  ,  ,   ,
	dcfsnz	WREG,W,ACCESS	
 bra	SpCh_R3 ; 3.  - 0.1    ,
	dcfsnz	WREG,W,ACCESS	
 bra	SpCh_R4 ; 4.     IRAMX   ,
;	dcfsnz	WREG,W,ACCESS	
 bra	SpCh_R5 ; 5. //        ,
;	dcfsnz	WREG,W,ACCESS	
; bra	SpCh__R6 ; 6.         .
SpCh_R0 ; 0.  ,     ,  
;*******	bcf	ADCON0,ADON,ACCESS	;  -     
;     
	ITRIP_Stop	;  ITRIP      PWM
;3	  1  IRAMX  0-5  RA1/AN1
;	bsf		LATA,1,ACCESS	;  
;	bcf		TRISA,1,ACCESS	;    
 		call StopMotor	; OverRide PWM
	bcf PCPWM_Flag,3,ACCESS	;;3= /
	bcf PCPWM_Flag,4,ACCESS	;;4= Left/Right
	bcf PCPWM_Flag1,0,ACCESS;;0=  "",   ---.
	bcf PCPWM_Flag1,4,ACCESS;;4=  --
	bcf PCPWM_Flag1,5,ACCESS;;5=  /    (    )

;	movf	PCPWM_Alarm_Route,W,BANKED	;   
; bz		Alarm_R0 ; 0.  , PowerOnReset.
;	dcfsnz	WREG,W,ACCESS	
; bra	Alarm_R1 ; 1. , , ,  .
;
;Alarm_R0 ; 0.  , PowerOnReset.
	movff	Tic_10_Counter,Alarm_DelayStamp	;   
	incf	PCPWM_SpCh_Route,F,BANKED	;   ""
;*******	bsf	ADCON0,ADON,ACCESS	;    
		retlw	0x01	;      
SpCh_R1 ; 1.  -   ,    .
	bcf PCPWM_Flag1,1,ACCESS;;1=   / 
	bcf PCPWM_Flag1,4,ACCESS;;4=  --
	movf	PCPWM_Alarm_Route,W,BANKED	;   ,    
 bz		Alarm_R10 ; 0.  , PowerOnReset.
;        
;	dcfsnz	WREG,W,ACCESS	
; bra	Alarm_R11 ; 1. , , ,  .
	WaitTimeL	d'20',Tic_10_Counter,ACCESS,Alarm_DelayStamp,BANKED,0xD1
		bra	DoneWait
Alarm_R10 ; 0.  , PowerOnReset.
	bcf PCPWM_Flag,4,ACCESS	;;4= Left/Right
	WaitTimeL	d'5',Tic_10_Counter,ACCESS,Alarm_DelayStamp,BANKED,0xD2
		bra	DoneWait
DoneWait
	incf	PCPWM_SpCh_Route,F,BANKED	;   ""
		retlw	0x02 ;      
SpCh_R2 ; 2.  ,  ,   ,
;        
;       
 #ifndef __DEBUG;*******   -  
 movff	ADC_Out+5,WREG	;   16   
	sublw	PCPWM_StartCurrent;  WREG from Literal 
	btfss	_C			;     
 		retlw	0x03	;    -  
 movff	ADC_Out+7,WREG	;   16   
;	sublw	PCPWM_StartVoltage;  WREG from Literal 
	subwf	Par_UV,W,BANKED	;;       
	btfsc	_C			;     
 		retlw	0x04	;     -  
 #endif
;          -    
	btfsc	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
		bra	SpCh_R2_KeyWait
	movlf	0x80,PCPWM_WrkSpdBuf,BANKED;  50       
		bra	SpCh_R2_Next
;   /     
SpCh_R2_KeyWait
 #ifdef __DEBUG;*******  
	btfss	PORTE,1,ACCESS	; /;1=   "  /"
 #else
	btfss	PCPWM_Flag1,1,ACCESS;1=   "  /"
 #endif
;	btfss	PCPWM_Flag1,1,ACCESS;1=   /
  		retlw	0x05		;   
;         -   ?
;  -      1   ?
;       -  .
;	movff	PCPWM_Speed_M1,PCPWM_WrkSpdBuf	;   
 movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M0;      
 bsf		LCD_Flg1,0,ACCESS	;      
	btfss	PCPWM_Flag1,2,ACCESS;2=    /
		bra	Start_0_Pressed
;	movff	PCPWM_Speed_M0,PCPWM_WrkSpdBuf	;   
	movlf	0x80,PCPWM_WrkSpdBuf,BANKED;  50       
	bcf	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
Start_0_Pressed
;         .
;	btfss	PCPWM_Flag1,2,ACCESS;2=    /

;	btfsc	PCPWM_Flag1,2,ACCESS;2=    /		
; movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M1;      
;***************



SpCh_R2_Next
;    
;3	  1  IRAMX  0-5  RA1/AN1
	;bcf		LATA,1,ACCESS	;  
	;bsf		TRISA,1,ACCESS	;    
	PWM_Start	;   PWM   
	bcf	PCPWM_Flag1,1,ACCESS;1=   "  /"

	bsf PCPWM_Flag,3,ACCESS;;3= /
	bsf	PCPWM_Flag,6,ACCESS;6=   RealStop PCPWM Module -       
	movlf 0x1,PCPWM_SpeedReal,BANKED;    =1   .
;     " "      PCPWM 
	clrf    OVDCONS,ACCESS	;      
	movlw	b'11000000'	;   6 
	andwf	OVDCOND,F,ACCESS
 incf	PCPWM_SpCh_Route,F,BANKED	;   ""
	movff	Tic_10_Counter,Alarm_DelayStamp	;   
		retlw	0x06 ;     
SpCh_R3 ; 3.  - 0.1    ,
	WaitTimeL	d'2',Tic_10_Counter,ACCESS,Alarm_DelayStamp,BANKED,0xD3
	incf	PCPWM_SpCh_Route,F,BANKED	;   ""
		retlw	0x07 ;     
SpCh_R4 ; 4.     IRAMX   ,
	movff	ADC_Out+3,WREG	;   16   
	sublw	PCPWM_StartTermistor;  WREG from Literal 
	btfss	_C			;     
 		retlw	0x08	;    -  
	; PCPWM  
	movlw	b'111111'	;   6 
	iorwf	OVDCOND,F,ACCESS	;   
	bcf	PCPWM_Flag1,1,ACCESS;1=   "  /"
	clrf	PCPWM_Alarm_Route,BANKED	;   
	incf	PCPWM_SpCh_Route,F,BANKED	;   ""
		retlw	0x09  ;     
SpCh_R5 ; 5. //        ,
 #ifdef __DEBUG;*******    
	btfss	PORTE,1,ACCESS	; /;1=   "  /"
 #else
	btfss	PCPWM_Flag1,1,ACCESS;1=   "  /"
 #endif
		bra StopKeyNotPressed
	btfsc	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
		bra SecondTimeStopKeyPressed
	bsf	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
	bcf	PCPWM_Flag1,1,ACCESS;  "  /"
;             
;	movff	PCPWM_Speed_M1,PCPWM_WrkSpdBuf	;   
;	btfss	PCPWM_Flag1,2,ACCESS;2=    /
	movff	PCPWM_Speed_M0,PCPWM_WrkSpdBuf	;   
		bra StopKeyNotPressed
SetStandartSpeed
	bcf	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,
;      / 0,   1
	movlf	0x80,PCPWM_WrkSpdBuf,BANKED;  50       
		bra StopKeyNotPressed
SecondTimeStopKeyPressed
	bcf		PCPWM_Flag1,1,ACCESS;  "  /"
 	movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M0;      
	bsf		LCD_Flg1,0,ACCESS	;      

	btfsc	PCPWM_Flag1,2,ACCESS;2=    /		
 		bra	SetStandartSpeed	;movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M1;      
	bcf		PCPWM_Flag,3,ACCESS	; /  

	bcf	PCPWM_Flag1,4,ACCESS;   ;4=  --
	clrf	PCPWM_WorkSpeed,BANKED;   
StopKeyNotPressed
	bsf PCPWM_Flag1,5,ACCESS;;5=  /    (    )
;        
	btfsc	PCPWM_Flag1,4,ACCESS;4=  --
		bcf		PCPWM_Flag,3,ACCESS		; /    -
	btfss	PCPWM_Flag,3,ACCESS		; /
		bra	SpdStop

;	MoveEditToWorkSpeed	;    
 movff	PCPWM_WrkSpdBuf,PCPWM_WorkSpeed;****       

 #ifdef LCD_Work_Present
	btfss	LCD_Flg1,3,ACCESS	;  0=/ 
	 movff	PCPWM_Speed,PCPWM_WorkSpeed;,W,BANKED;     /.
 #endif
		bra	SpdRun ;     
SpdStop
	 clrf	PCPWM_WorkSpeed,BANKED;     
SpdRun

	movf	PCPWM_SpeedReal,W,BANKED;    .
	cpfseq	PCPWM_WorkSpeed,BANKED;     /. 
		bra	SpeedNoEq;   
	btfss	_Z	;  Z    
		bra	StopAfterRun ;return	;  ,   
;    ,  
	btfsc	PCPWM_Flag1,0,ACCESS;   " -"
		bra	RunAfterStop
	btfsc	PCPWM_Flag1,4,ACCESS;   ;4=  --
		bra	RunAfterStop
	btfsc 	PCPWM_Flag,6,ACCESS;6= RealStop PCPWM Module -       
		bra	StopMotor
;     
	btfsc	PCPWM_Flag,3,ACCESS	; /
		retlw	0x10 ;     ""
 bcf PCPWM_Flag1,5,ACCESS;;5=  /    (    )
;      "" 
;    OVERTEMP
 ITRIP_Stop	;  ITRIP      PWM
;	bsf		LATA,1,ACCESS	;  
;	bcf		TRISA,1,ACCESS	;    
	
	movff	Tic_10_Counter,Alarm_DelayStamp	;   
	clrf	PCPWM_Alarm_Route,BANKED ;   =   
	movlf	0x1,PCPWM_SpCh_Route,BANKED	;    "" -  1.5 
		retlw	0x11 ;   
;************
MotorFault	;      PWM   IRAMX
;  ,   ,    -   
;************
;	bsf		LATA,1,ACCESS	;  
;	bcf		TRISA,1,ACCESS	;    

	infsnz	WREG,F,ACCESS	;
		setf	WREG,ACCESS	;
	movff	WREG,PCPWM_Alarm_Route;
	clrf	WREG,ACCESS	;        
	movff	WREG,PCPWM_SpCh_Route	;     

  ITRIP_Stop	;  ITRIP      PWM

	bsf	PCPWM_Flag1,3,ACCESS;3= 0=     50 ,      /
	bcf PCPWM_Flag,3,ACCESS	;;3= /
	bcf PCPWM_Flag1,0,ACCESS;;0=  "",   ---.
	bcf PCPWM_Flag1,4,ACCESS;;4=  --
	bcf PCPWM_Flag1,5,ACCESS;;5=  /    (    )

	Beeper 0xA0	;  ;  500 
;		return ;      PWM
StopMotor:
 ITRIP_Stop	;  ITRIP      PWM
	bcf	PCPWM_Flag,6,ACCESS;6= RealStop PCPWM Module -       
; ****   PCPWM 
	clrf    OVDCONS,ACCESS	;      
	movlw	b'11000000'	;   6 
	andwf	OVDCOND,F,ACCESS
;	clrf    OVDCOND,ACCESS	;   ,    
;   1 
		retlw	0x12 ;  
RunAfterStop	;  -
	btg	PCPWM_Flag,4,ACCESS		; / -   
	bcf	PCPWM_Flag1,4,ACCESS;   ;4=  --

;	movff	PCPWM_Speed_M1,PCPWM_WorkSpeed	;   
;	btfss	PCPWM_Flag1,2,ACCESS;2=    /
;	movff	PCPWM_Speed_M0,PCPWM_WorkSpeed	;   

;	MoveEditToWorkSpeed	;    
 movff	PCPWM_WrkSpdBuf,PCPWM_WorkSpeed;****       
 
	bsf	PCPWM_Flag,3,ACCESS		; /
		retlw	0x13 
StopAfterRun;  ,   
	btfss	PCPWM_Flag1,0,ACCESS;   " -"
		retlw	0x14 

	bcf	PCPWM_Flag,3,ACCESS		; /       

; *****       -  
;	btfss	PCPWM_Flag1,2,ACCESS;2=    /
; movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M0;      
;	btfsc	PCPWM_Flag1,2,ACCESS;2=    /		
; movff	PCPWM_WrkSpdBuf,PCPWM_Speed_M1;      

	clrf	PCPWM_WorkSpeed,BANKED;   
		retlw	0x15 
SpeedNoEq;   
 movf PCPWM_SpeedReal,W,BANKED
 btfss	_Z	;  Z   movf PCPWM_SpeedReal,W,BANKED
	bra	MotorRunning
 btfsc	PCPWM_Flag,6,ACCESS;6= RealStop PCPWM Module -       
	bra	MotorRunning
 bsf	PCPWM_Flag,6,ACCESS;6= RealStop PCPWM Module -       
;*****   PCPWM  
	movlw	b'111111'	;   6 
	iorwf	OVDCOND,F,ACCESS	;

MotorRunning
	cpfsgt	PCPWM_WorkSpeed,BANKED;     .
		bra	SpeedDec
;	cpfsgt	PCPWM_WorkSpeed,BANKED;     .
;		bra	SpeedInc

SpeedInc; 0  
	infsnz	PCPWM_SpeedReal,F,BANKED;     .
	 setf	PCPWM_SpeedReal,BANKED;     .
		retlw	0x16 
SpeedDec; FF  
	decf	PCPWM_SpeedReal,F,BANKED;     .
	btfss	_C	;   ?
	 clrf	PCPWM_SpeedReal,BANKED;     =0.	
		retlw	0x17 
