;  ************************     ************************-
; Define_LCD_Key_Enc.inc #define ParamDelta ;     

Msg21	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"  Speed Motor="	;
 #ifdef	PCPWM_Present
	db  0x17,0x0C,0xff,0x10;
		dw					PCPWM_Speed			;
 #endif
	 db 0;  

Msg22	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"      V/F Amp="	;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
	dw						PCPWM_Amp			;
 #endif
	 db 0;,0,0,0 ;   

Msg23	db	d'01',0x12	;
	dw	Encoder_Count	;
 db							 "    V/F Start="	;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
		dw					PCPWM_VFStart		;	
 #endif
	 db 0;   
Msg24	db	d'01',0x12							;
	dw	Encoder_Count							;
 db 						"   Accelerate="	;
 #ifdef	PCPWM_Present
	db	0x17,0x01,0xff,0x10						;
		dw					PCPWM_Accelerate	;
	db	0										;
 #endif
	 db 0;  

Msg25	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"W1 Temp Flt="		;
 #ifdef	W1_Pin
	db 0x17,0x83,0x7d,0x14;
		dw					Par_K;
	db	0	;
 #endif
	 db 0;   

Msg26	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"W1 Tmp1 Flt="		;
 #ifdef	W1_Pin
	db 0x17,0x83,0x7d,0x14;
		dw					Par_K1;
	db	0	;
 #endif
	 db 0;   

Msg27	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"Termist Fault="		;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
		dw					Par_T;
	db	0	;
 #endif
	 db 0;   

Msg28	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"OverCurrent A="		;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
		dw					Par_A;
	db	0	;
 #endif
	 db 0;   
Msg29	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"OverVoltage V="		;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
		dw					Par_V;
	db	0	;
 #endif
	 db 0;   

Msg30	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						" UnderVolt UV="		;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10	;
		dw					Par_UV;
	db	0	;
 #endif
	 db 0;   

Msg31	db	d'01',0x12							;
	dw	Encoder_Count							;
 db 						"MAX Spd Index="	;
 #ifdef	PCPWM_Present
	db	0x17,0x00,0xff,0x10						;
		dw					PCPWM_MaxSpdIndx	;
	db	0										;
 #endif
	 db 0;  

Msg32	db	d'01',0x12							;
	dw	Encoder_Count							;
 #ifdef	CyrTable
  db 						" ="		;
 #else
  db 						"   460V Adj="		;
 #endif



 #ifdef	ADC_Present
;	db	;    /  
	db	0x17,0x00,0x00,0x14;0x14 ;    
		dw					Adc_Corr+0			;
	db	0										;
 #endif
	 db 0;  

Msg33	db	d'01',0x12							;
	dw	Encoder_Count							;
 db 						"  7A 1 Adj= "		;
 #ifdef	ADC_Present
	db	0x17,0x00,0x00,0x14;0x14 ;    
		dw					Adc_Corr+1			;
	db	0										;
 #endif
	 db 0;  

Msg34	db	d'01',0x12							;
	dw	Encoder_Count	;
 db 						"Termist Adj="		;
 #ifdef	ADC_Present
	db	0x17,0x00,0x00,0x14;0x14 ;    
		dw					Adc_Corr+2			;
	db	0						;
 #endif
	 db 0;  

Msg35	db	d'01',0x12	;
	dw	Encoder_Count	;
 db 						"  25A 3 Adj="		;
 #ifdef	ADC_Present
	db	0x17,0x00,0x00,0x14;0x14 ;    
		dw					Adc_Corr+3			;
	db	0						;
 #endif
	 db 0;  

Msg36	db	d'01',0x12	; 
	dw	Encoder_Count	;   6  ,   4 
 db 						" Variant 4s="		;
 	db	0x17,d'43',d'48',0x14;    
		dw					LCD_6_4				;
	db	0						;
 	 db 0;  


Msg37	db	d'01',0x12	; 
	dw	Encoder_Count	;   6  ,   4 
 db 						"Debounce Time="		;
 	db	0x17,d'43',d'48',0x10;    
		dw					LCD_DebounceTimeOut;
	db	0						;
 	 db 0;  


Msg38;
Msg39;
Msg40;
Msg41;
Msg42;
	db	d'01',0x12	;
	dw	Encoder_Count	;
 db "   Delay Test="	;
 #ifdef	PCPWM_Present
	db	0x17,0x01,0xff,0x10		;
		dw	DelayCuriosityIndex	;
	db	0						;
 #endif
 	 db 0;  


Msg43 ; 4  6  
 db	d'84'	;        
 db 0x16,d'84',"1=",0x19;;   
  #ifdef	ADC_Present
 	dw	Adc_Volt+0	;
 db "V,",0x19;   
	dw	 Adc_Amp+0	;
 #endif
  db "A,",0x10;;   Hex - 2 
	dw	KeyBuf;,0;  4 
 db 0;   4  6 

Msg44 ; 4  6  
 db	d'84'	;        
 db 0x16,d'84',"2=",0x19;;   
  #ifdef	ADC_Present
 	dw	Adc_Volt+2
 db "C,",0x19;   
	dw	 Adc_Amp+2;
  #endif
 db "A,",0x10;;   Hex - 2 
	dw	KeyBuf;,0;  4 
 db 0;   4  6 

Msg45 ; 4  6  
 db	d'84'	;        
 db 0x16,d'84',"3=",0x19;;   
  #ifdef	ADC_Present
 	dw	Adc_Volt+4
 db "V,",0x19;   
	dw	 Adc_Amp+4,"A,"; 4    
 #endif
 db 0;   4  6 

Msg46 ; 4  6  
 db	d'84'	;        
 db 0x16,d'84',"4=",0x19;;   
  #ifdef	ADC_Present
 	dw	Adc_Volt+6
 db "V,",0x19;   
	dw	 Adc_Amp+6,"A,"; 4    
 #endif
 db 0;   4  6 

Msg47 ; 4  6  
 db	d'84'	;        
 #ifdef	ADC_Present
 db 0x16,d'84',0x11;;   
 	dw	ADC_Out
 db "M=",0x11;   
	dw	ADC_Max_Out;,","; 4    
 db "  E",0x10;;   Hex - 2 
	dw	ADC_ERR_Counter	;
 #endif
 #ifdef	PCPWM_Present		; 
 db 0x10;;   Hex - 2 
	dw	PCPWM_Err	; 
 #endif						; 
 db " ",0x10;;   Hex - 2 
	dw	KeyBuf;,0;  4 
 db 0;   4  6 
Msg48
Msg49
Msg50 ; 4  6  
 db	d'84'	;        
 db 0x16,d'84',"5=",0x10;;   
  #ifdef	ADC_Present
 	dw	ADC_Out+0x1	;    0  2 
 db 0x10;   
	dw	ADC_Out+0x3	;    1  3  IRAMX
 db 0x10;   
	dw	ADC_Out+0x5	;    2  4  
 db 0x10;   
	dw	ADC_Out+0x7	;    3  5  
 db 0x10;   
	dw	ADC_Out+0x9	;    8  10
 db 0x10;   
	dw	ADC_Out+0xB	;    5  7
 db 0x10;   
	dw	ADC_Out+0xD	;    6  8
 db 0x10;   
	dw	ADC_Out+0xF	;    7  9
 #endif
 db "  ",0;   4  6 


	 db 0;   

 
