;******************************************
;    Filename: PCPWM_3F_4431.asm           *
;    Date:                                *
;    File Version: 000.001                *
;    Author: PSW.RU                       *
;    Company: Labs                        *
	#include Define.inc	;     
;*******************************
;    -   
;*******************************
 #ifdef	PCPWM_Present

	global	PCPWM_Task, SpeedCalc,SpeedChange,StopMotor,MotorFault
	global	RevCalc,DelayCuriosity ;   .
	Extern	InitAll;,HighInt


;******************************************
PCPWM	code	
SpeedCalc	;     100 
 #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   
SpeedChange	;   /   / PCPWM 
 #include Proj_Dir\PCPWM_3F\SpeedChange.inc	;  -   
	retlw	0x15	;  -    
RevCalc	;
 #include Proj_Dir\PCPWM_3F\Rev_Calc.inc	;  -   
 #include Proj_Dir\PCPWM_3F\SinTableLoad.inc	;     

PCPWM_Task	;  PCPWM 11.7/23.4/18.75 	
;*******************************************
		PCPWM_Page	; BSR for PCPWM Task
;	bcf	PCPWM_Flag,0,ACCESS	;  ,  PCPWM   
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
;	btfsc	KeyBuf,1,ACCESS	;    ?
;		bra	DoneClear	;  ""  
;	clrf	Angle_1+0,BANKED	; 
;	clrf	Angle_1+1,BANKED	;  
;	clrf	Angle_1+2,BANKED	;  
;DoneClear	;
 #ifdef	PCPWM_1PhCalc	;;    -  1   .
	dcfsnz	SynFaza,F,BANKED	; 
	bra		Faza_1 ; -1
	movf	SynFaza,W,BANKED	; 
	dcfsnz	WREG,W,ACCESS		;  
	bra		Faza_2 ; -2
	dcfsnz	WREG,W,ACCESS		;   
	bra		Faza_3 ; -3
;    3    	
Faza_1 ; -1
	movlf	0x3,SynFaza,BANKED	;   
 #else
	movff24	Angle_1,Angle_2	;   
	movff24	Angle_1,Angle_3	;   

;	btfss	PCPWM_Flag,4,ACCESS		; / - 
;		bra	FwdAng
	Add24L	Angle_2,BANKED,0x555555	;       +1/3 	
	Add24L	Angle_3,BANKED,0xAAAAAA	;       +2/3 
;	bra	AngDone
;FwdAng:
;	Add24L	Angle_2,BANKED,0xAAAAAA	;       +2/3 	
;	Add24L	Angle_3,BANKED,0x555555	;       +1/3 
;AngDone:
;
 SinTableLoad	Angle_2+2,PDC1L	;      
 SinTableLoad	Angle_3+2,PDC2L	;      
 #endif;#ifdef	PCPWM_1PhCalc	;;    -  1   .

 ;bsf PWMCON1,UDIS, ACCESS;;1 = Updates from duty cycle and period buffer registers are disabled.
 ;movff	Angle_1+2,PCPWM_Ang1 ;      BANK0
 SinTableLoad	Angle_1+2,PDC0L	;      
	;	movff16	SynMulBuf+1,PCPWM_PDC0; :2	;      BANK0
	;	movff16	Syn16,PCPWM_Syn0;	:2	;      BANK0
 ;bcf PWMCON1,UDIS, ACCESS;;0 = Updates from duty cycle and period buffer registers are enabled.
	bcf	PCPWM_Flag,0,ACCESS	;  ,  PCPWM   

		return	;
 #ifdef	PCPWM_1PhCalc	;;    -  1   .
Faza_2 ; -1
	movff24	Angle_1,Angle_2	;   
;        24   -,  Add24L

;Add24L	Angle_2,BANKED,0x555555	;       +1/3 	

;	btfss	PCPWM_Flag,4,ACCESS		; / - 
;		bra	FwdAng2
	Add24L	Angle_2,BANKED,0x555555	;       +1/3 	
;	bra	AngDone2
;FwdAng2:
;	Add24L	Angle_2,BANKED,0xAAAAAA	;       +2/3 	
;AngDone2:
;
 ;bsf PWMCON1,UDIS, ACCESS;;1 = Updates from duty cycle and period buffer registers are disabled.
	;	movff	Angle_1+2,PCPWM_Ang1 ;      BANK0
 SinTableLoad	Angle_2+2,PDC1L	;      
	;	movff16	SynMulBuf+1,PCPWM_PDC0; :2	;      BANK0
	;	movff16	Syn16,PCPWM_Syn0;	:2	;      BANK0
 ;bcf PWMCON1,UDIS, ACCESS;;0 = Updates from duty cycle and period buffer registers are enabled.
	bcf	PCPWM_Flag,0,ACCESS	;  ,  PCPWM   
		return	;
Faza_3 ; -1
	movff24	Angle_1,Angle_3	;   
;        24   -,  Add24L

;	Add24L	Angle_3,BANKED,0xAAAAAA	;       +2/3 

;	btfss	PCPWM_Flag,4,ACCESS		; / - 
;		bra	FwdAng3
;
	Add24L	Angle_3,BANKED,0xAAAAAA	;       +2/3 
;	bra	AngDone3
;FwdAng3:
;
;	Add24L	Angle_3,BANKED,0x555555	;       +1/3 
;AngDone3:
;


 ;bsf PWMCON1,UDIS, ACCESS;;1 = Updates from duty cycle and period buffer registers are disabled.
	;	movff	Angle_1+2,PCPWM_Ang1 ;      BANK0
 SinTableLoad	Angle_3+2,PDC2L	;      
	;	movff16	SynMulBuf+1,PCPWM_PDC0; :2	;      BANK0
	;	movff16	Syn16,PCPWM_Syn0;	:2	;      BANK0
 ;bcf PWMCON1,UDIS, ACCESS;;0 = Updates from duty cycle and period buffer registers are enabled.
	bcf	PCPWM_Flag,0,ACCESS	;  ,  PCPWM   
		return	;
 #endif;#ifdef	PCPWM_1PhCalc	;;    -  1   .

DelayCuriosity	;      ,
;  3   ,   8+4*index
;  0x15       ,
;  0x0F     .
	movf	DelayCuriosityIndex,W,ACCESS
DelayLoop;
	nop	;
	decfsz	WREG,W,ACCESS
		bra	DelayLoop;
	return	;

;Table_Speed	code_pack ;0x800	; 
Table_Sinus	code_pack ;0x800			;        - BRA  
	global	Table_Sinus	;    -   ,    .
		;      NOP
	goto	InitAll			;       - 
Table_Sinus	;   16  
; 256   2  -.
 #include Proj_Dir\PCPWM_3F\SinusTable_dw_16.inc	;   -  .
;      24 :
	errorlevel  -311 ; 		Message[311] 
;Message[311] C:\MICROCHIP\_PRG\RTOS_3F_4431\PCPWM_3F\SPEEDTABLE_DB.INC 65 :
; Operand of HIGH operator was larger than H'FFFF'.
Table_Simples	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S2.inc	; 
Simples_100	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_100.inc	; 
Simples_200	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_200.inc	; 
Simples_400	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_400.inc	; 
Simples_800	;;     256 ,    MakeSimple.bas/exe
 #include Proj_Dir\PCPWM_3F\S_800.inc	; 
 	errorlevel  +311 ; 	Message[311] 

;*******************************
;    -   
;*******************************
 #endif ;ifdef	PCPWM_Present
;End of program
		END
